//========================================================================================
//
//	File:				FWStrmRW.cpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFound.hpp"

#ifndef FWSTRMRW_H
#include "FWStrmRW.h"
#endif

#ifndef FWPRIDEB_H
#include "FWPriDeb.h"
#endif

#ifndef FWEXCLIB_H
#include "FWExcLib.h"
#endif

#include "SLASinks.xh"
#include "SLObjReg.xh"

//========================================================================================
//	RunTime Info
//========================================================================================

#ifdef FW_BUILD_MAC
#pragma segment FWStream
#endif

FW_DEFINE_AUTO(FW_CReadableStream)
FW_DEFINE_AUTO(FW_CWritableStream)

//========================================================================================
//	CLASS FW_CReadableStream
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CReadableStream::FW_CReadableStream
//----------------------------------------------------------------------------------------

FW_CReadableStream::FW_CReadableStream(FW_OSink* sink,
									   FW_OObjectRegistry* objectRegistry,
									   int numberFormat)
{
	::FW_FailOnError(FW_PrivReadableStream_Construct(this, sink, objectRegistry, numberFormat));
	FW_END_CONSTRUCTOR
}

//----------------------------------------------------------------------------------------
// FW_CReadableStream::FW_CReadableStream
//----------------------------------------------------------------------------------------

FW_CReadableStream::FW_CReadableStream(FW_HReadableStream hStream)
{
	::FW_FailOnError(FW_PrivReadableStream_CopyConstruct(this, hStream));
	FW_END_CONSTRUCTOR
}

//----------------------------------------------------------------------------------------
// FW_CReadableStream::~FW_CReadableStream
//----------------------------------------------------------------------------------------

FW_CReadableStream::~FW_CReadableStream()
{
	FW_START_DESTRUCTOR
	::FW_FailOnError(FW_PrivReadableStream_Destruct(this));
}


//========================================================================================
//	CLASS FW_CWritableStream
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CWritableStream::FW_CWritableStream
//----------------------------------------------------------------------------------------

FW_CWritableStream::FW_CWritableStream(FW_OSink* sink,
									   FW_OObjectRegistry* objectRegistry,
									   int numberFormat)
{
	::FW_FailOnError(FW_PrivWritableStream_Construct(this, sink, objectRegistry, numberFormat));
	FW_END_CONSTRUCTOR
}

//----------------------------------------------------------------------------------------
// FW_CWritableStream::FW_CWritableStream
//----------------------------------------------------------------------------------------

FW_CWritableStream::FW_CWritableStream(FW_HWritableStream hStream)
{
	::FW_FailOnError(FW_PrivWritableStream_CopyConstruct(this, hStream));
	FW_END_CONSTRUCTOR
}

//----------------------------------------------------------------------------------------
// FW_CWritableStream::~FW_CWritableStream
//----------------------------------------------------------------------------------------

FW_CWritableStream::~FW_CWritableStream()
{
	FW_START_DESTRUCTOR
	::FW_FailOnError(FW_PrivWritableStream_Destruct(this));
}
