//========================================================================================
//
//	File:				SLASinks.cpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#include "FWFound.hpp"

#ifndef FWODEXCE_H
#include "FWODExce.h"
#endif

#ifndef FWPRIMEM_H
#include "FWPriMem.h"
#endif

#ifndef FWPRIDEB_H
#include "FWPriDeb.h"
#endif

#define VARIABLE_MACROS
#define FW_OSink_Class_Source
#include "SLASinks.xih"

#ifdef FW_BUILD_MAC
#pragma segment FWStream
#endif

//----------------------------------------------------------------------------------------
// FW_OSinkGetReadableBytes
//----------------------------------------------------------------------------------------

SOM_Scope long  SOMLINK FW_OSink__GetReadableBytes(FW_OSink* somSelf, Environment* ev)
{
FW_UNUSED(somSelf);
FW_UNUSED(ev);
    FW_SUBCLASS_RESPONSIBILITY("FW_OSinkGetReadableBytes");
    return 0;
}


//----------------------------------------------------------------------------------------
// FW_OSinkRead
//----------------------------------------------------------------------------------------

SOM_Scope void  SOMLINK FW_OSink__Read(FW_OSink *somSelf, Environment *ev,
		void* destination,
		long count)
{
FW_UNUSED(somSelf);
FW_UNUSED(ev);
FW_UNUSED(destination);
FW_UNUSED(count);
    FW_SUBCLASS_RESPONSIBILITY("FW_OSinkRead");
}


//----------------------------------------------------------------------------------------
// FW_OSinkGetWritableBytes
//----------------------------------------------------------------------------------------

SOM_Scope long  SOMLINK FW_OSink__GetWritableBytes(FW_OSink *somSelf, Environment *ev)
{
FW_UNUSED(somSelf);
FW_UNUSED(ev);
    FW_SUBCLASS_RESPONSIBILITY("FW_OSinkGetWritableBytes");
    return 0;
}

/*
 *  ---- Optimized sink protocol
 *  These four methods make it possible to optimize sink access
 *  to buffered devices that can expose their buffer.
 *  Sinks that are not buffered, or cannot expose their buffer
 *  will not be able to take advantage of this protocol.  Such
 *  sinks should not override these methods, as the default behavior
 *  is correct in that case.
 *  Note that the ODF Stream classes will take advantage of this
 *  protocol for sinks that support it, but no other ODF classes
 *  will, and it is not expected that these methods would be used
 *  by other clients.  We could therefore grant friend access
 *  to the streams classes and then declare these functions
 *  to be private, but that seems unnecessarily restrictive.
 */


//----------------------------------------------------------------------------------------
// FW_OSinkWrite
//----------------------------------------------------------------------------------------

SOM_Scope void  SOMLINK FW_OSink__Write(FW_OSink *somSelf, Environment *ev,
		void* source,
		long count)
{
FW_UNUSED(somSelf);
FW_UNUSED(ev);
FW_UNUSED(source);
FW_UNUSED(count);
    FW_SUBCLASS_RESPONSIBILITY("FW_OSinkWrite");
}


//----------------------------------------------------------------------------------------
// FW_OSinksomInit
//----------------------------------------------------------------------------------------

SOM_Scope void  SOMLINK FW_OSink__somInit(FW_OSink *somSelf)
{
    FW_OSink_parent_SOMObject_somInit(somSelf);
}


//----------------------------------------------------------------------------------------
// FW_OSinksomUninit
//----------------------------------------------------------------------------------------

SOM_Scope void  SOMLINK FW_OSink__somUninit(FW_OSink *somSelf)
{
    FW_OSink_parent_SOMObject_somUninit(somSelf);
}


